from setuptools import setup, find_packages
import os

with open(os.path.join(os.path.dirname(__file__), "README.md"), "r", encoding="utf-8") as fh:
    long_description = fh.read()

setup(
    name="ai_puti",
    version="0.1.0b4",
    description="puti: MultiAgent-based package for LLM",
    long_description=long_description,
    long_description_content_type="text/markdown",
    keywords="llm, multiagent, package, agent, twikit, openai, websearch, terminal, python, file, fastapi, mcp",
    maintainer="obstaclews",
    author="obstaclews",
    author_email="obstaclesws@qq.com",
    url="https://github.com/aivoyager/puti",
    packages=find_packages(),
    include_package_data=True,
    install_requires=[
        "pytz==2022.6",
        "click==8.1.3",
        "requests",
        "celery==5.4.0",
        "colorama==0.4.6",
        "fastapi==0.115.11",
        "httpx==0.28.1",
        "langchain==0.3.20",
        "langchain_core==0.3.43",
        "langchain_openai==0.3.8",
        "loguru==0.7.3",
        "openai==1.65.4",
        "Pillow==11.1.0",
        "pydantic==2.10.6",
        "pydantic_core",
        "pydantic_settings==2.8.1",
        "pytest==8.3.5",
        "PyYAML==6.0.2",
        "twikit==2.3.3",
        "uvicorn==0.34.0",
        "websocket_client==1.8.0",
        "mypy==1.15.0",
        "ollama==0.4.7",
        "pandas==2.2.3",
        "python-box==7.3.2",
        "mcp==1.6.0",
        "faiss-cpu==1.10.0",
        "psutil==6.0.0",
        "tenacity==8.2.3",
        "redis==5.2.1",
        "gevent==25.4.2",
        "googlesearch-python==1.3.0",
        "pymysql==1.1.1",
        "llama_index==0.12.37",
    ],
    python_requires=">=3.10",
    classifiers=[
        "Programming Language :: Python :: 3",
        "License :: OSI Approved :: MIT License",
        "Operating System :: OS Independent",
    ],
    entry_points={
        # 'console_scripts': [
        #     'puti=puti.main:main',
        # ],
    },
)
